import {StyleSheet} from 'react-native';
import {horizontalScale} from '../utils';

const borderWidthStyle = StyleSheet.create({
  'border-none': {borderWidth: 0},
  border: {borderWidth: horizontalScale(1)},
  'border-md': {borderWidth: horizontalScale(2)},
  'border-lg': {borderWidth: horizontalScale(4)},
  'border-xl': {borderWidth: horizontalScale(8)},
  'border-t-none': {borderTopWidth: 0},
  'border-t': {borderTopWidth: horizontalScale(1)},
  'border-t-md': {borderTopWidth: horizontalScale(2)},
  'border-t-lg': {borderTopWidth: horizontalScale(4)},
  'border-t-xl': {borderTopWidth: horizontalScale(8)},
  'border-b-none': {borderBottomWidth: 0},
  'border-b': {borderBottomWidth: horizontalScale(1)},
  'border-b-md': {borderBottomWidth: horizontalScale(2)},
  'border-b-lg': {borderBottomWidth: horizontalScale(4)},
  'border-b-xl': {borderBottomWidth: horizontalScale(8)},
  'border-l-none': {borderLeftWidth: 0},
  'border-l': {borderLeftWidth: horizontalScale(1)},
  'border-l-md': {borderLeftWidth: horizontalScale(2)},
  'border-l-lg': {borderLeftWidth: horizontalScale(4)},
  'border-l-xl': {borderLeftWidth: horizontalScale(8)},
  'border-r-none': {borderRightWidth: 0},
  'border-r': {borderRightWidth: horizontalScale(1)},
  'border-r-md': {borderRightWidth: horizontalScale(2)},
  'border-r-lg': {borderRightWidth: horizontalScale(4)},
  'border-r-xl': {borderRightWidth: horizontalScale(8)},
  'border-x-none': {borderLeftWidth: 0, borderRightWidth: 0},
  'border-x': {
    borderLeftWidth: horizontalScale(1),
    borderRightWidth: horizontalScale(1),
  },
  'border-x-md': {
    borderLeftWidth: horizontalScale(2),
    borderRightWidth: horizontalScale(2),
  },
  'border-x-lg': {
    borderLeftWidth: horizontalScale(4),
    borderRightWidth: horizontalScale(4),
  },
  'border-x-xl': {
    borderLeftWidth: horizontalScale(8),
    borderRightWidth: horizontalScale(8),
  },
  'border-y-none': {borderTopWidth: 0, borderBottomWidth: 0},
  'border-y': {
    borderTopWidth: horizontalScale(1),
    borderBottomWidth: horizontalScale(1),
  },
  'border-y-md': {
    borderTopWidth: horizontalScale(2),
    borderBottomWidth: horizontalScale(2),
  },
  'border-y-lg': {
    borderTopWidth: horizontalScale(4),
    borderBottomWidth: horizontalScale(4),
  },
  'border-y-xl': {
    borderTopWidth: horizontalScale(8),
    borderBottomWidth: horizontalScale(8),
  },
});
const borderColorStyles = StyleSheet.create({
  'border-dashed': {borderStyle: 'dashed'},
  'border-dotted': {borderStyle: 'dotted'},
  'border-solid': {borderStyle: 'solid'},
  'border-dark': {borderColor: 'black'},
  'border-dark-light': {borderColor: 'white'},
  'border-light': {borderColor: 'white'},
  'border-white': {borderColor: 'white'},
  'border-black': {borderColor: 'black'},
  'border-secondary': {borderColor: '#f5f5f5'},
  'border-error': {borderColor: 'red'},
  'border-success': {borderColor: 'green'},
  'border-warning': {borderColor: 'yellow'},
  'border-transparent': {borderColor: 'transparent'},
});

const roundedStyles = StyleSheet.create({
  'rounded-none': {borderRadius: 0},
  'rounded-sm': {borderRadius: horizontalScale(2)},
  rounded: {borderRadius: horizontalScale(4)},
  'rounded-md': {borderRadius: horizontalScale(6)},
  'rounded-lg': {borderRadius: horizontalScale(8)},
  'rounded-xl': {borderRadius: horizontalScale(12)},
  'rounded-2xl': {borderRadius: horizontalScale(16)},
  'rounded-3xl': {borderRadius: horizontalScale(24)},
  'rounded-full': {borderRadius: horizontalScale(9999)},
  'rounded-t-none': {borderTopLeftRadius: 0, borderTopRightRadius: 0},
  'rounded-t-sm': {
    borderTopLeftRadius: horizontalScale(2),
    borderTopRightRadius: horizontalScale(2),
  },
  'rounded-t': {
    borderTopLeftRadius: horizontalScale(4),
    borderTopRightRadius: horizontalScale(4),
  },
  'rounded-t-md': {
    borderTopLeftRadius: horizontalScale(6),
    borderTopRightRadius: horizontalScale(6),
  },
  'rounded-t-lg': {
    borderTopLeftRadius: horizontalScale(8),
    borderTopRightRadius: horizontalScale(8),
  },
  'rounded-t-xl': {
    borderTopLeftRadius: horizontalScale(12),
    borderTopRightRadius: horizontalScale(12),
  },
  'rounded-t-2xl': {
    borderTopLeftRadius: horizontalScale(16),
    borderTopRightRadius: horizontalScale(16),
  },
  'rounded-t-3xl': {
    borderTopLeftRadius: horizontalScale(24),
    borderTopRightRadius: horizontalScale(24),
  },
  'rounded-t-full': {
    borderTopLeftRadius: horizontalScale(9999),
    borderTopRightRadius: horizontalScale(9999),
  },
  'rounded-b-none': {borderBottomLeftRadius: 0, borderBottomRightRadius: 0},
  'rounded-b-sm': {
    borderBottomLeftRadius: horizontalScale(2),
    borderBottomRightRadius: horizontalScale(2),
  },
  'rounded-b': {
    borderBottomLeftRadius: horizontalScale(4),
    borderBottomRightRadius: horizontalScale(4),
  },
  'rounded-b-md': {
    borderBottomLeftRadius: horizontalScale(6),
    borderBottomRightRadius: horizontalScale(6),
  },
  'rounded-b-lg': {
    borderBottomLeftRadius: horizontalScale(8),
    borderBottomRightRadius: horizontalScale(8),
  },
  'rounded-b-xl': {
    borderBottomLeftRadius: horizontalScale(12),
    borderBottomRightRadius: horizontalScale(12),
  },
  'rounded-b-2xl': {
    borderBottomLeftRadius: horizontalScale(16),
    borderBottomRightRadius: horizontalScale(16),
  },
  'rounded-b-3xl': {
    borderBottomLeftRadius: horizontalScale(24),
    borderBottomRightRadius: horizontalScale(24),
  },
  'rounded-b-full': {
    borderBottomLeftRadius: horizontalScale(9999),
    borderBottomRightRadius: horizontalScale(9999),
  },
  'rounded-l-none': {borderTopLeftRadius: 0, borderBottomLeftRadius: 0},
  'rounded-l-sm': {
    borderTopLeftRadius: horizontalScale(2),
    borderBottomLeftRadius: horizontalScale(2),
  },
  'rounded-l': {
    borderTopLeftRadius: horizontalScale(4),
    borderBottomLeftRadius: horizontalScale(4),
  },
  'rounded-l-md': {
    borderTopLeftRadius: horizontalScale(6),
    borderBottomLeftRadius: horizontalScale(6),
  },
  'rounded-l-lg': {
    borderTopLeftRadius: horizontalScale(8),
    borderBottomLeftRadius: horizontalScale(8),
  },
  'rounded-l-xl': {
    borderTopLeftRadius: horizontalScale(12),
    borderBottomLeftRadius: horizontalScale(12),
  },
  'rounded-l-2xl': {
    borderTopLeftRadius: horizontalScale(16),
    borderBottomLeftRadius: horizontalScale(16),
  },
  'rounded-l-3xl': {
    borderTopLeftRadius: horizontalScale(24),
    borderBottomLeftRadius: horizontalScale(24),
  },
  'rounded-l-full': {
    borderTopLeftRadius: horizontalScale(9999),
    borderBottomLeftRadius: horizontalScale(9999),
  },
  'rounded-tl-none': {borderTopLeftRadius: 0},
  'rounded-tl-sm': {borderTopLeftRadius: horizontalScale(2)},
  'rounded-tl': {borderTopLeftRadius: horizontalScale(4)},
  'rounded-tl-md': {borderTopLeftRadius: horizontalScale(6)},
  'rounded-tl-lg': {borderTopLeftRadius: horizontalScale(8)},
  'rounded-tl-xl': {borderTopLeftRadius: horizontalScale(12)},
  'rounded-tl-2xl': {borderTopLeftRadius: horizontalScale(16)},
  'rounded-tl-3xl': {borderTopLeftRadius: horizontalScale(24)},
  'rounded-tl-full': {borderTopLeftRadius: horizontalScale(9999)},
  'rounded-tr-none': {borderTopRightRadius: 0},
  'rounded-tr-sm': {borderTopRightRadius: horizontalScale(2)},
  'rounded-tr': {borderTopRightRadius: horizontalScale(4)},
  'rounded-tr-md': {borderTopRightRadius: horizontalScale(6)},
  'rounded-tr-lg': {borderTopRightRadius: horizontalScale(8)},
  'rounded-tr-xl': {borderTopRightRadius: horizontalScale(12)},
  'rounded-tr-2xl': {borderTopRightRadius: horizontalScale(16)},
  'rounded-tr-3xl': {borderTopRightRadius: horizontalScale(24)},
  'rounded-tr-full': {borderTopRightRadius: horizontalScale(9999)},
  'rounded-bl-none': {borderBottomLeftRadius: 0},
  'rounded-bl-sm': {borderBottomLeftRadius: horizontalScale(2)},
  'rounded-bl': {borderBottomLeftRadius: horizontalScale(4)},
  'rounded-bl-md': {borderBottomLeftRadius: horizontalScale(6)},
  'rounded-bl-lg': {borderBottomLeftRadius: horizontalScale(8)},
  'rounded-bl-xl': {borderBottomLeftRadius: horizontalScale(12)},
  'rounded-bl-2xl': {borderBottomLeftRadius: horizontalScale(16)},
  'rounded-bl-3xl': {borderBottomLeftRadius: horizontalScale(24)},
  'rounded-bl-full': {borderBottomLeftRadius: horizontalScale(9999)},
  'rounded-br-none': {borderBottomRightRadius: 0},
  'rounded-br-sm': {borderBottomRightRadius: horizontalScale(2)},
  'rounded-br': {borderBottomRightRadius: horizontalScale(4)},
  'rounded-br-md': {borderBottomRightRadius: horizontalScale(6)},
  'rounded-br-lg': {borderBottomRightRadius: horizontalScale(8)},
  'rounded-br-xl': {borderBottomRightRadius: horizontalScale(12)},
  'rounded-br-2xl': {borderBottomRightRadius: horizontalScale(16)},
  'rounded-br-3xl': {borderBottomRightRadius: horizontalScale(24)},
  'rounded-br-full': {borderBottomRightRadius: horizontalScale(9999)},
});

const borderWidthNoneScaleStyle = StyleSheet.create({
  'border-none': {borderWidth: 0},
  border: {borderWidth: 1},
  'border-md': {borderWidth: 2},
  'border-lg': {borderWidth: 4},
  'border-xl': {borderWidth: 8},
  'border-t-none': {borderTopWidth: 0},
  'border-t': {borderTopWidth: 1},
  'border-t-md': {borderTopWidth: 2},
  'border-t-lg': {borderTopWidth: 4},
  'border-t-xl': {borderTopWidth: 8},
  'border-b-none': {borderBottomWidth: 0},
  'border-b': {borderBottomWidth: 1},
  'border-b-md': {borderBottomWidth: 2},
  'border-b-lg': {borderBottomWidth: 4},
  'border-b-xl': {borderBottomWidth: 8},
  'border-l-none': {borderLeftWidth: 0},
  'border-l': {borderLeftWidth: 1},
  'border-l-md': {borderLeftWidth: 2},
  'border-l-lg': {borderLeftWidth: 4},
  'border-l-xl': {borderLeftWidth: 8},
  'border-r-none': {borderRightWidth: 0},
  'border-r': {borderRightWidth: 1},
  'border-r-md': {borderRightWidth: 2},
  'border-r-lg': {borderRightWidth: 4},
  'border-r-xl': {borderRightWidth: 8},
  'border-x-none': {borderLeftWidth: 0, borderRightWidth: 0},
  'border-x': {
    borderLeftWidth: 1,
    borderRightWidth: 1,
  },
  'border-x-md': {
    borderLeftWidth: 2,
    borderRightWidth: 2,
  },
  'border-x-lg': {
    borderLeftWidth: 4,
    borderRightWidth: 4,
  },
  'border-x-xl': {
    borderLeftWidth: 8,
    borderRightWidth: 8,
  },
  'border-y-none': {borderTopWidth: 0, borderBottomWidth: 0},
  'border-y': {
    borderTopWidth: 1,
    borderBottomWidth: 1,
  },
  'border-y-md': {
    borderTopWidth: 2,
    borderBottomWidth: 2,
  },
  'border-y-lg': {
    borderTopWidth: 4,
    borderBottomWidth: 4,
  },
  'border-y-xl': {
    borderTopWidth: 8,
    borderBottomWidth: 8,
  },
});

const roundedNoneScaleStyles = StyleSheet.create({
  'rounded-none': {borderRadius: 0},
  'rounded-sm': {borderRadius: 2},
  rounded: {borderRadius: 4},
  'rounded-md': {borderRadius: 6},
  'rounded-lg': {borderRadius: 8},
  'rounded-xl': {borderRadius: 12},
  'rounded-2xl': {borderRadius: 16},
  'rounded-3xl': {borderRadius: 24},
  'rounded-full': {borderRadius: 9999},
  'rounded-t-none': {borderTopLeftRadius: 0, borderTopRightRadius: 0},
  'rounded-t-sm': {
    borderTopLeftRadius: 2,
    borderTopRightRadius: 2,
  },
  'rounded-t': {
    borderTopLeftRadius: 4,
    borderTopRightRadius: 4,
  },
  'rounded-t-md': {
    borderTopLeftRadius: 6,
    borderTopRightRadius: 6,
  },
  'rounded-t-lg': {
    borderTopLeftRadius: 8,
    borderTopRightRadius: 8,
  },
  'rounded-t-xl': {
    borderTopLeftRadius: 12,
    borderTopRightRadius: 12,
  },
  'rounded-t-2xl': {
    borderTopLeftRadius: 16,
    borderTopRightRadius: 16,
  },
  'rounded-t-3xl': {
    borderTopLeftRadius: 24,
    borderTopRightRadius: 24,
  },
  'rounded-t-full': {
    borderTopLeftRadius: 9999,
    borderTopRightRadius: 9999,
  },
  'rounded-b-none': {borderBottomLeftRadius: 0, borderBottomRightRadius: 0},
  'rounded-b-sm': {
    borderBottomLeftRadius: 2,
    borderBottomRightRadius: 2,
  },
  'rounded-b': {
    borderBottomLeftRadius: 4,
    borderBottomRightRadius: 4,
  },
  'rounded-b-md': {
    borderBottomLeftRadius: 6,
    borderBottomRightRadius: 6,
  },
  'rounded-b-lg': {
    borderBottomLeftRadius: 8,
    borderBottomRightRadius: 8,
  },
  'rounded-b-xl': {
    borderBottomLeftRadius: 12,
    borderBottomRightRadius: 12,
  },
  'rounded-b-2xl': {
    borderBottomLeftRadius: 16,
    borderBottomRightRadius: 16,
  },
  'rounded-b-3xl': {
    borderBottomLeftRadius: 24,
    borderBottomRightRadius: 24,
  },
  'rounded-b-full': {
    borderBottomLeftRadius: 9999,
    borderBottomRightRadius: 9999,
  },
  'rounded-l-none': {borderTopLeftRadius: 0, borderBottomLeftRadius: 0},
  'rounded-l-sm': {
    borderTopLeftRadius: 2,
    borderBottomLeftRadius: 2,
  },
  'rounded-l': {
    borderTopLeftRadius: 4,
    borderBottomLeftRadius: 4,
  },
  'rounded-l-md': {
    borderTopLeftRadius: 6,
    borderBottomLeftRadius: 6,
  },
  'rounded-l-lg': {
    borderTopLeftRadius: 8,
    borderBottomLeftRadius: 8,
  },
  'rounded-l-xl': {
    borderTopLeftRadius: 12,
    borderBottomLeftRadius: 12,
  },
  'rounded-l-2xl': {
    borderTopLeftRadius: 16,
    borderBottomLeftRadius: 16,
  },
  'rounded-l-3xl': {
    borderTopLeftRadius: 24,
    borderBottomLeftRadius: 24,
  },
  'rounded-l-full': {
    borderTopLeftRadius: 9999,
    borderBottomLeftRadius: 9999,
  },
  'rounded-tl-none': {borderTopLeftRadius: 0},
  'rounded-tl-sm': {borderTopLeftRadius: 2},
  'rounded-tl': {borderTopLeftRadius: 4},
  'rounded-tl-md': {borderTopLeftRadius: 6},
  'rounded-tl-lg': {borderTopLeftRadius: 8},
  'rounded-tl-xl': {borderTopLeftRadius: 12},
  'rounded-tl-2xl': {borderTopLeftRadius: 16},
  'rounded-tl-3xl': {borderTopLeftRadius: 24},
  'rounded-tl-full': {borderTopLeftRadius: 9999},
  'rounded-tr-none': {borderTopRightRadius: 0},
  'rounded-tr-sm': {borderTopRightRadius: 2},
  'rounded-tr': {borderTopRightRadius: 4},
  'rounded-tr-md': {borderTopRightRadius: 6},
  'rounded-tr-lg': {borderTopRightRadius: 8},
  'rounded-tr-xl': {borderTopRightRadius: 12},
  'rounded-tr-2xl': {borderTopRightRadius: 16},
  'rounded-tr-3xl': {borderTopRightRadius: 24},
  'rounded-tr-full': {borderTopRightRadius: 9999},
  'rounded-bl-none': {borderBottomLeftRadius: 0},
  'rounded-bl-sm': {borderBottomLeftRadius: 2},
  'rounded-bl': {borderBottomLeftRadius: 4},
  'rounded-bl-md': {borderBottomLeftRadius: 6},
  'rounded-bl-lg': {borderBottomLeftRadius: 8},
  'rounded-bl-xl': {borderBottomLeftRadius: 12},
  'rounded-bl-2xl': {borderBottomLeftRadius: 16},
  'rounded-bl-3xl': {borderBottomLeftRadius: 24},
  'rounded-bl-full': {borderBottomLeftRadius: 9999},
  'rounded-br-none': {borderBottomRightRadius: 0},
  'rounded-br-sm': {borderBottomRightRadius: 2},
  'rounded-br': {borderBottomRightRadius: 4},
  'rounded-br-md': {borderBottomRightRadius: 6},
  'rounded-br-lg': {borderBottomRightRadius: 8},
  'rounded-br-xl': {borderBottomRightRadius: 12},
  'rounded-br-2xl': {borderBottomRightRadius: 16},
  'rounded-br-3xl': {borderBottomRightRadius: 24},
  'rounded-br-full': {borderBottomRightRadius: 9999},
});

export const classBorderStyles = {
  ...borderWidthStyle,
  ...borderColorStyles,
  ...roundedNoneScaleStyles,
};

export const classBorderNoneScaleStyles = {
  ...borderWidthNoneScaleStyle,
  ...borderColorStyles,
  ...roundedStyles,
};
