import {StyleSheet} from 'react-native';
import {device, horizontalScale} from '../utils';

const widthStyles = StyleSheet.create({
  w: {width: horizontalScale(1)},
  'w-0': {width: 0},
  'w-0.5': {width: horizontalScale(2)},
  'w-1': {width: horizontalScale(4)},
  'w-1.5': {width: horizontalScale(6)},
  'w-2': {width: horizontalScale(8)},
  'w-2.5': {width: horizontalScale(10)},
  'w-3': {width: horizontalScale(12)},
  'w-3.5': {width: horizontalScale(14)},
  'w-4': {width: horizontalScale(16)},
  'w-5': {width: horizontalScale(20)},
  'w-6': {width: horizontalScale(24)},
  'w-7': {width: horizontalScale(28)},
  'w-8': {width: horizontalScale(32)},
  'w-9': {width: horizontalScale(36)},
  'w-10': {width: horizontalScale(40)},
  'w-11': {width: horizontalScale(44)},
  'w-12': {width: horizontalScale(48)},
  'w-14': {width: horizontalScale(56)},
  'w-16': {width: horizontalScale(64)},
  'w-20': {width: horizontalScale(80)},
  'w-24': {width: horizontalScale(96)},
  'w-28': {width: horizontalScale(112)},
  'w-32': {width: horizontalScale(128)},
  'w-36': {width: horizontalScale(144)},
  'w-40': {width: horizontalScale(160)},
  'w-44': {width: horizontalScale(176)},
  'w-48': {width: horizontalScale(192)},
  'w-52': {width: horizontalScale(208)},
  'w-56': {width: horizontalScale(224)},
  'w-60': {width: horizontalScale(240)},
  'w-64': {width: horizontalScale(256)},
  'w-72': {width: horizontalScale(288)},
  'w-80': {width: horizontalScale(320)},
  'w-96': {width: horizontalScale(384)},
  'w-1/2': {width: '50%'},
  'w-1/3': {width: '33.333333%'},
  'w-2/3': {width: '66.666667%'},
  'w-1/4': {width: '25%'},
  'w-3/4': {width: '75%'},
  'w-1/5': {width: '20%'},
  'w-2/5': {width: '40%'},
  'w-3/5': {width: '60%'},
  'w-4/5': {width: '80%'},
  'w-full': {width: '100%'},
  'w-screen': {width: device.width},
  'min-w': {minWidth: horizontalScale(1)},
  'min-w-0': {minWidth: 0},
  'min-w-0.5': {minWidth: horizontalScale(2)},
  'min-w-1': {minWidth: horizontalScale(4)},
  'min-w-1.5': {minWidth: horizontalScale(6)},
  'min-w-2': {minWidth: horizontalScale(8)},
  'min-w-2.5': {minWidth: horizontalScale(10)},
  'min-w-3': {minWidth: horizontalScale(12)},
  'min-w-3.5': {minWidth: horizontalScale(14)},
  'min-w-4': {minWidth: horizontalScale(16)},
  'min-w-5': {minWidth: horizontalScale(20)},
  'min-w-6': {minWidth: horizontalScale(24)},
  'min-w-7': {minWidth: horizontalScale(28)},
  'min-w-8': {minWidth: horizontalScale(32)},
  'min-w-9': {minWidth: horizontalScale(36)},
  'min-w-10': {minWidth: horizontalScale(40)},
  'min-w-11': {minWidth: horizontalScale(44)},
  'min-w-12': {minWidth: horizontalScale(48)},
  'min-w-14': {minWidth: horizontalScale(56)},
  'min-w-16': {minWidth: horizontalScale(64)},
  'min-w-20': {minWidth: horizontalScale(80)},
  'min-w-24': {minWidth: horizontalScale(96)},
  'min-w-28': {minWidth: horizontalScale(112)},
  'min-w-32': {minWidth: horizontalScale(128)},
  'min-w-36': {minWidth: horizontalScale(144)},
  'min-w-40': {minWidth: horizontalScale(160)},
  'min-w-44': {minWidth: horizontalScale(176)},
  'min-w-48': {minWidth: horizontalScale(192)},
  'min-w-52': {minWidth: horizontalScale(208)},
  'min-w-56': {minWidth: horizontalScale(224)},
  'min-w-60': {minWidth: horizontalScale(240)},
  'min-w-64': {minWidth: horizontalScale(256)},
  'min-w-72': {minWidth: horizontalScale(288)},
  'min-w-80': {minWidth: horizontalScale(320)},
  'min-w-96': {minWidth: horizontalScale(384)},
  'min-w-1/2': {minWidth: '50%'},
  'min-w-1/3': {minWidth: '33.333333%'},
  'min-w-2/3': {minWidth: '66.666667%'},
  'min-w-1/4': {minWidth: '25%'},
  'min-w-3/4': {minWidth: '75%'},
  'min-w-1/5': {minWidth: '20%'},
  'min-w-2/5': {minWidth: '40%'},
  'min-w-3/5': {minWidth: '60%'},
  'min-w-4/5': {minWidth: '80%'},
  'min-w-full': {minWidth: '100%'},
  'min-w-screen': {minWidth: device.width},
});

const heightStyles = StyleSheet.create({
  h: {height: horizontalScale(1)},
  'h-0': {height: 0},
  'h-0.5': {height: horizontalScale(2)},
  'h-1': {height: horizontalScale(4)},
  'h-1.5': {height: horizontalScale(6)},
  'h-2': {height: horizontalScale(8)},
  'h-2.5': {height: horizontalScale(10)},
  'h-3': {height: horizontalScale(12)},
  'h-3.5': {height: horizontalScale(14)},
  'h-4': {height: horizontalScale(16)},
  'h-5': {height: horizontalScale(20)},
  'h-6': {height: horizontalScale(24)},
  'h-7': {height: horizontalScale(28)},
  'h-8': {height: horizontalScale(32)},
  'h-9': {height: horizontalScale(36)},
  'h-10': {height: horizontalScale(40)},
  'h-11': {height: horizontalScale(44)},
  'h-12': {height: horizontalScale(48)},
  'h-14': {height: horizontalScale(56)},
  'h-16': {height: horizontalScale(64)},
  'h-20': {height: horizontalScale(80)},
  'h-24': {height: horizontalScale(96)},
  'h-28': {height: horizontalScale(112)},
  'h-32': {height: horizontalScale(128)},
  'h-36': {height: horizontalScale(144)},
  'h-40': {height: horizontalScale(160)},
  'h-44': {height: horizontalScale(176)},
  'h-48': {height: horizontalScale(192)},
  'h-52': {height: horizontalScale(208)},
  'h-56': {height: horizontalScale(224)},
  'h-60': {height: horizontalScale(240)},
  'h-64': {height: horizontalScale(256)},
  'h-72': {height: horizontalScale(288)},
  'h-80': {height: horizontalScale(320)},
  'h-96': {height: horizontalScale(384)},
  'h-1/2': {height: '50%'},
  'h-1/3': {height: '33.333333%'},
  'h-2/3': {height: '66.666667%'},
  'h-1/4': {height: '25%'},
  'h-3/4': {height: '75%'},
  'h-1/5': {height: '20%'},
  'h-2/5': {height: '40%'},
  'h-3/5': {height: '60%'},
  'h-4/5': {height: '80%'},
  'h-full': {height: '100%'},
  'h-screen': {height: device.height},
});

const widthNoneScaleStyles = StyleSheet.create({
  w: {width: 1},
  'w-0': {width: 0},
  'w-0.5': {width: 2},
  'w-1': {width: 4},
  'w-1.5': {width: 6},
  'w-2': {width: 8},
  'w-2.5': {width: 10},
  'w-3': {width: 12},
  'w-3.5': {width: 14},
  'w-4': {width: 16},
  'w-5': {width: 20},
  'w-6': {width: 24},
  'w-7': {width: 28},
  'w-8': {width: 32},
  'w-9': {width: 36},
  'w-10': {width: 40},
  'w-11': {width: 44},
  'w-12': {width: 48},
  'w-14': {width: 56},
  'w-16': {width: 64},
  'w-20': {width: 80},
  'w-24': {width: 96},
  'w-28': {width: 112},
  'w-32': {width: 128},
  'w-36': {width: 144},
  'w-40': {width: 160},
  'w-44': {width: 176},
  'w-48': {width: 192},
  'w-52': {width: 208},
  'w-56': {width: 224},
  'w-60': {width: 240},
  'w-64': {width: 256},
  'w-72': {width: 288},
  'w-80': {width: 320},
  'w-96': {width: 384},
  'w-1/2': {width: '50%'},
  'w-1/3': {width: '33.333333%'},
  'w-2/3': {width: '66.666667%'},
  'w-1/4': {width: '25%'},
  'w-3/4': {width: '75%'},
  'w-1/5': {width: '20%'},
  'w-2/5': {width: '40%'},
  'w-3/5': {width: '60%'},
  'w-4/5': {width: '80%'},
  'w-full': {width: '100%'},
  'w-screen': {width: device.width},
  'min-w': {minWidth: 1},
  'min-w-0': {minWidth: 0},
  'min-w-0.5': {minWidth: 2},
  'min-w-1': {minWidth: 4},
  'min-w-1.5': {minWidth: 6},
  'min-w-2': {minWidth: 8},
  'min-w-2.5': {minWidth: 10},
  'min-w-3': {minWidth: 12},
  'min-w-3.5': {minWidth: 14},
  'min-w-4': {minWidth: 16},
  'min-w-5': {minWidth: 20},
  'min-w-6': {minWidth: 24},
  'min-w-7': {minWidth: 28},
  'min-w-8': {minWidth: 32},
  'min-w-9': {minWidth: 36},
  'min-w-10': {minWidth: 40},
  'min-w-11': {minWidth: 44},
  'min-w-12': {minWidth: 48},
  'min-w-14': {minWidth: 56},
  'min-w-16': {minWidth: 64},
  'min-w-20': {minWidth: 80},
  'min-w-24': {minWidth: 96},
  'min-w-28': {minWidth: 112},
  'min-w-32': {minWidth: 128},
  'min-w-36': {minWidth: 144},
  'min-w-40': {minWidth: 160},
  'min-w-44': {minWidth: 176},
  'min-w-48': {minWidth: 192},
  'min-w-52': {minWidth: 208},
  'min-w-56': {minWidth: 224},
  'min-w-60': {minWidth: 240},
  'min-w-64': {minWidth: 256},
  'min-w-72': {minWidth: 288},
  'min-w-80': {minWidth: 320},
  'min-w-96': {minWidth: 384},
  'min-w-1/2': {minWidth: '50%'},
  'min-w-1/3': {minWidth: '33.333333%'},
  'min-w-2/3': {minWidth: '66.666667%'},
  'min-w-1/4': {minWidth: '25%'},
  'min-w-3/4': {minWidth: '75%'},
  'min-w-1/5': {minWidth: '20%'},
  'min-w-2/5': {minWidth: '40%'},
  'min-w-3/5': {minWidth: '60%'},
  'min-w-4/5': {minWidth: '80%'},
  'min-w-full': {minWidth: '100%'},
  'min-w-screen': {minWidth: device.width},
});

const heightNoneScaleStyles = StyleSheet.create({
  h: {height: 1},
  'h-0': {height: 0},
  'h-0.5': {height: 2},
  'h-1': {height: 4},
  'h-1.5': {height: 6},
  'h-2': {height: 8},
  'h-2.5': {height: 10},
  'h-3': {height: 12},
  'h-3.5': {height: 14},
  'h-4': {height: 16},
  'h-5': {height: 20},
  'h-6': {height: 24},
  'h-7': {height: 28},
  'h-8': {height: 32},
  'h-9': {height: 36},
  'h-10': {height: 40},
  'h-11': {height: 44},
  'h-12': {height: 48},
  'h-14': {height: 56},
  'h-16': {height: 64},
  'h-20': {height: 80},
  'h-24': {height: 96},
  'h-28': {height: 112},
  'h-32': {height: 128},
  'h-36': {height: 144},
  'h-40': {height: 160},
  'h-44': {height: 176},
  'h-48': {height: 192},
  'h-52': {height: 208},
  'h-56': {height: 224},
  'h-60': {height: 240},
  'h-64': {height: 256},
  'h-72': {height: 288},
  'h-80': {height: 320},
  'h-96': {height: 384},
  'h-1/2': {height: '50%'},
  'h-1/3': {height: '33.333333%'},
  'h-2/3': {height: '66.666667%'},
  'h-1/4': {height: '25%'},
  'h-3/4': {height: '75%'},
  'h-1/5': {height: '20%'},
  'h-2/5': {height: '40%'},
  'h-3/5': {height: '60%'},
  'h-4/5': {height: '80%'},
  'h-full': {height: '100%'},
  'h-screen': {height: device.height},
});

export const classSizeStyle = {
  ...widthStyles,
  ...heightStyles,
};

export const classSizeNoneScaleStyle = {
  ...widthNoneScaleStyles,
  ...heightNoneScaleStyles,
};
